#define _CRT_SECURE_NO_WARNINGS

#include<iostream>
#include<cstdint>
#include<cmath>
#include<algorithm>
#include<iomanip>
#include<stack>
#include<queue>
#include<set>
#include<unordered_set>
#include<map>
#include<unordered_map>
#include<vector>
#include<string>
#include<random>
#include<stdio.h>
#include<numeric>
#include<bitset>
#include<cstring>

using namespace std;

#define ll long long
#define ld long double
#define all(x) begin(x), end(x)
#define int long long
// g++ -D_GLIBCXX_DEBUG -o main main.cpp

/*#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avhull[i].x,fma")*/
// #pragma GCC optimize("O3")

const long long MAXN = 1e3 + 500;
const long double PI = acosl(-1);
const int inf = 2e9;
const long long INF = 1e17;
const long long SZ = (1 << 19);
const int SIZE = 1e7 + 5;
const long long MOD = 1e9 + 7; // 998244353;
const long double eps = 1e-6;

std::random_device rd;
std::mt19937 ran(rd());

int getBit(int num, int nbit) {
    int mask = (1 << nbit);
    return (num & mask) ? 1 : 0;
}

template<typename T>
ostream& operator<<(ostream& out, vector<T>& arr) {
    for (auto& i : arr) out << i << ' ';
    return out;
}

template<typename T>
istream& operator>>(istream& in, vector<T>& arr) {
    for (auto& i : arr) in >> i;
    return in;
}

struct mirror {
    int x1, y1, x2, y2, p;
};

int ang; double lum;

void go(int& x, int& y) {
    if (ang == 0) {
        x++;
    }
    if (ang == 45) {
        x++; y++;
    }
    if (ang == 90) {
        y++;
    }
    if (ang == 135) {
        x--; y++;
    }
    if (ang == 180) {
        x--;
    }
    if (ang == 225) {
        x--; y--;
    }
    if (ang == 270) {
        y--;
    }
    if (ang == 315) {
        x++; y--;
    }
    return;
}

double dist(int x, int y, int X, int Y) {
    return (x - X) * (x - X) + (y - Y) * (y - Y);
}

bool in(mirror m, int x, int y) {
    int x1 = min(m.x1, m.x2), x2 = max(m.x1, m.x2);
    int y1 = min(m.y1, m.y2), y2 = max(m.y1, m.y2);
    if (x1 <= x && x <= x2 && y1 <= y && y <= y2) {
        if (x1 == x2 || y1 == y2) {
            return true;
        }
        if (abs(sqrtl(dist(m.x1, m.y1, x, y)) + sqrtl(dist(m.x2, m.y2, x, y)) - sqrtl(dist(m.x1, m.y1, m.x2, m.y2))) <= eps) {
            return true;
        }
        return false;
    }
    return false;
}

void solve() {
    int x = 0, y = 0;
    cin >> ang >> lum;
    int n; cin >> n;
    vector<mirror> ms(n);
    for (int i = 0; i < n; ++i) {
        cin >> ms[i].x1 >> ms[i].y1 >> ms[i].x2 >> ms[i].y2 >> ms[i].p;
    }
    int X, Y; cin >> X >> Y;
    if (sqrtl(dist(x, y, X, Y)) <= 0.5) {
        cout << (int)lum << '\n'; return;
    }
    double _lum = lum;
    int prev = -1;
    for (int _ = 0; _ < 1000 * 1000; ++_) {
        if (lum / _lum < 0.1) {
            cout << ms[prev].x1 << ' ' << ms[prev].y1 << ' ' << ms[prev].x2 << ' ' << ms[prev].y2 << ' ' << (int)lum << '\n';
            break;
        }
        go(x, y);
        //cout << x << ' ' << y << '\n';
        if (sqrtl(dist(x, y, X, Y)) <= 0.5) {
            cout << (int)lum << '\n'; return;
        }
        for (int i = 0; i < n; ++i) {
            if (in(ms[i], x, y)) {
                prev = i;
                lum *= (100 - ms[i].p) * 1.0 / 100;
                //cout << x << ' ' << y << '\n';
                if (ang == 0) {
                    // horizontal
                    if (ms[i].y1 == ms[i].y2) {
                        ang = (ang + 180) % 360;
                    }
                    // vertical
                    else if (ms[i].x1 == ms[i].x2) {
                        ang = (ang + 180) % 360;
                    }
                    else {
                        int x1 = min(ms[i].x1, ms[i].x2), x2 = max(ms[i].x1, ms[i].x2);
                        pair<int, int> p1, p2;
                        if (ms[i].x1 == x1) {
                            p1 = { ms[i].x1, ms[i].y1 };
                            p2 = { ms[i].x2, ms[i].y2 };
                        }
                        else {
                            p1 = { ms[i].x2, ms[i].y2 };
                            p2 = { ms[i].x1, ms[i].y1 };
                        }
                        // /
                        if (p1.second < p2.second) {
                            ang = (ang + 90) % 360;
                        }
                        // \'
                        if (p1.second > p2.second) {
                            ang = (ang + 270) % 360;
                        }
                    }
                }
                else if (ang == 45) {
                    // horizontal
                    if (ms[i].y1 == ms[i].y2) {
                        ang = 315;
                    }
                    // vertical
                    else if (ms[i].x1 == ms[i].x2) {
                        ang = 135;
                    }
                    else {
                        int x1 = min(ms[i].x1, ms[i].x2), x2 = max(ms[i].x1, ms[i].x2);
                        pair<int, int> p1, p2;
                        if (ms[i].x1 == x1) {
                            p1 = { ms[i].x1, ms[i].y1 };
                            p2 = { ms[i].x2, ms[i].y2 };
                        }
                        else {
                            p1 = { ms[i].x2, ms[i].y2 };
                            p2 = { ms[i].x1, ms[i].y1 };
                        }
                        // /
                        if (p1.second < p2.second) {
                            ang = (ang + 180) % 360;
                        }
                        // \'
                        if (p1.second > p2.second) {
                            ang = (ang + 180) % 360;
                        }
                    }
                }   
                else if (ang == 90) {
                    // horizontal
                    if (ms[i].y1 == ms[i].y2) {
                        ang = (ang + 180) % 360;
                    }
                    // vertical
                    else if (ms[i].x1 == ms[i].x2) {
                        ang = (ang + 180) % 360;
                    }
                    else {
                        int x1 = min(ms[i].x1, ms[i].x2), x2 = max(ms[i].x1, ms[i].x2);
                        pair<int, int> p1, p2;
                        if (ms[i].x1 == x1) {
                            p1 = { ms[i].x1, ms[i].y1 };
                            p2 = { ms[i].x2, ms[i].y2 };
                        }
                        else {
                            p1 = { ms[i].x2, ms[i].y2 };
                            p2 = { ms[i].x1, ms[i].y1 };
                        }
                        // /
                        if (p1.second < p2.second) {
                            ang = 0;
                        }
                        // \'
                        if (p1.second > p2.second) {
                            ang = 180;
                        }
                    }
                }
                else if (ang == 135) {
                    // horizontal
                    if (ms[i].y1 == ms[i].y2) {
                        ang = 225;
                    }
                    // vertical
                    else if (ms[i].x1 == ms[i].x2) {
                        ang = 45;
                    }
                    else {
                        int x1 = min(ms[i].x1, ms[i].x2), x2 = max(ms[i].x1, ms[i].x2);
                        pair<int, int> p1, p2;
                        if (ms[i].x1 == x1) {
                            p1 = { ms[i].x1, ms[i].y1 };
                            p2 = { ms[i].x2, ms[i].y2 };
                        }
                        else {
                            p1 = { ms[i].x2, ms[i].y2 };
                            p2 = { ms[i].x1, ms[i].y1 };
                        }
                        // /
                        if (p1.second < p2.second) {
                            ang = (ang + 180) % 360;
                        }
                        // \'
                        if (p1.second > p2.second) {
                            ang = (ang + 180) % 360;
                        }
                    }
                }
                else if (ang == 180) {
                    // horizontal
                    if (ms[i].y1 == ms[i].y2) {
                        ang = (ang + 180) % 360;
                    }
                    // vertical
                    else if (ms[i].x1 == ms[i].x2) {
                        ang = (ang + 180) % 360;
                    }
                    else {
                        int x1 = min(ms[i].x1, ms[i].x2), x2 = max(ms[i].x1, ms[i].x2);
                        pair<int, int> p1, p2;
                        if (ms[i].x1 == x1) {
                            p1 = { ms[i].x1, ms[i].y1 };
                            p2 = { ms[i].x2, ms[i].y2 };
                        }
                        else {
                            p1 = { ms[i].x2, ms[i].y2 };
                            p2 = { ms[i].x1, ms[i].y1 };
                        }
                        // /
                        if (p1.second < p2.second) {
                            ang = 270;
                        }
                        // \'
                        if (p1.second > p2.second) {
                            ang = 90;
                        }
                    }
                }
                else if (ang == 225) {
                    // horizontal
                    if (ms[i].y1 == ms[i].y2) {
                        ang = 135;
                    }
                    // vertical
                    else if (ms[i].x1 == ms[i].x2) {
                        ang = 315;
                    }
                    else {
                        int x1 = min(ms[i].x1, ms[i].x2), x2 = max(ms[i].x1, ms[i].x2);
                        pair<int, int> p1, p2;
                        if (ms[i].x1 == x1) {
                            p1 = { ms[i].x1, ms[i].y1 };
                            p2 = { ms[i].x2, ms[i].y2 };
                        }
                        else {
                            p1 = { ms[i].x2, ms[i].y2 };
                            p2 = { ms[i].x1, ms[i].y1 };
                        }
                        // /
                        if (p1.second < p2.second) {
                            ang = (ang + 180) % 360;
                        }
                        // \'
                        if (p1.second > p2.second) {
                            ang = (ang + 180) % 360;
                        }
                    }
                }
                else if (ang == 270) {
                    // horizontal
                    if (ms[i].y1 == ms[i].y2) {
                        ang = (ang + 180) % 360;
                    }
                    // vertical
                    else if (ms[i].x1 == ms[i].x2) {
                        ang = (ang + 180) % 360;
                    }
                    else {
                        int x1 = min(ms[i].x1, ms[i].x2), x2 = max(ms[i].x1, ms[i].x2);
                        pair<int, int> p1, p2;
                        if (ms[i].x1 == x1) {
                            p1 = { ms[i].x1, ms[i].y1 };
                            p2 = { ms[i].x2, ms[i].y2 };
                        }
                        else {
                            p1 = { ms[i].x2, ms[i].y2 };
                            p2 = { ms[i].x1, ms[i].y1 };
                        }
                        // /
                        if (p1.second < p2.second) {
                            ang = 90;
                        }
                        // \'
                        if (p1.second > p2.second) {
                            ang = 0;
                        }
                    }
                }
                else  if (ang == 315) {
                    // horizontal
                    if (ms[i].y1 == ms[i].y2) {
                        ang = 45;
                    }
                    // vertical
                    else if (ms[i].x1 == ms[i].x2) {
                        ang = 225;
                    }
                    else {
                        int x1 = min(ms[i].x1, ms[i].x2), x2 = max(ms[i].x1, ms[i].x2);
                        pair<int, int> p1, p2;
                        if (ms[i].x1 == x1) {
                            p1 = { ms[i].x1, ms[i].y1 };
                            p2 = { ms[i].x2, ms[i].y2 };
                        }
                        else {
                            p1 = { ms[i].x2, ms[i].y2 };
                            p2 = { ms[i].x1, ms[i].y1 };
                        }
                        // /
                        if (p1.second < p2.second) {
                            ang = (ang + 180) % 360;
                        }
                        // \'
                        if (p1.second > p2.second) {
                            ang = (ang + 180) % 360;
                        }
                    }
                }
            }
        }
    }
    return;
}

signed main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    cout << fixed << setprecision(5);
#else
    ios_base::sync_with_stdio(NULL); cin.tie(0); cout.tie(0);
    cout << fixed << setprecision(16);
#endif
    srand(time(NULL));
    //freopen("in.in", "r", stdin);
    //freopen("out.out", "w", stdout);
    int tt = 1;
    // cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}