def intersection(pos, dir, x0, y0, x1, y1):
    A = (y1 - y0)
    B = (x0 - x1)
    C = -(A*x0 + B*y0)
    #print(f'{A}*x + {B}*y + {C} = 0')
    if A*pos[0] + B*pos[1] + C == 0 and ((x0 - pos[0]) * (x1 - pos[0]) <= 0) and ((y0 - pos[1]) * (y1 - pos[1]) <= 0):
        lenN = (A**2 + B**2)**0.5
        if dir[0]*A + dir[1]*B < 0:
            return [A/lenN, B/lenN]
        return [-A/lenN, -B/lenN]
    else:
        return False

def reflect(dir, normal):
    k = (dir[0]*normal[0] + dir[1]*normal[1]) * -2
    return [round(normal[0]*k + dir[0]), round(normal[1]*k + dir[1])]

directions = [(1, 0), (1, 1), (0, 1), (-1, 1), (-1, 0), (-1, -1), (0, -1), (1, -1)]

ang, I = map(int, input().split())

Ibeg = I

ang //= 45

N = int(input())

planes = []

for _ in range(N):
    x0, y0, x1, y1, p = map(int, input().split())
    planes.append([x0, y0, x1, y1, p])

aim = list(map(int, input().split()))

pos = [0, 0]
vel = directions[ang]

last_plane = None

while pos != aim and 10*I >= Ibeg:
    #print(pos, vel)
    pos[0] += vel[0]
    pos[1] += vel[1]
    for plane in planes:
        normal = intersection(pos, vel, *(plane[:-1]))
        if normal != False:
            #print(normal, pos, vel)
            vel = reflect(vel, normal)
            #print(vel)
            I *= (1 - plane[-1]/100)
            last_plane = plane
            break
    if abs(pos[0]) > 50:
        break

if 10*I >= Ibeg:
    print(int(I))
else:
    print(*last_plane[:-1], int(I))
