#include<bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

struct pt {
    ld x = 0;
    ld y = 0;

    pt() {}
    explicit pt(int x, int y) : x(x), y(y) {}
    pt (const pt &from, const pt &to) {
        x = to.x - from.x;
        y = to.y - from.y;
    }

    ld operator*(const pt& other) const {
        return x * other.y - y * other.x;
    }

    ld operator^(const pt& other) const {
        return x * other.x + y * other.y;
    }

    bool in(const pt &s, const pt &f) const {
        pt sp(s, *this), fp(f, *this);
        return (sp ^ fp) <= 0 && sp * fp == 0;
    }

    bool operator==(const pt &other) const {
        return x == other.x && y == other.y;
    }

    ld alpha0() const {
        return x / sqrt(x * x + y * y);
    }
};

struct Obj {
    pt s, f;
    ld c;
};

istream &operator>> (istream &is, pt &p) {
    int x, y;
    is >> x >> y;
    p.x = x;
    p.y = y;
    return is;
}

ostream &operator<< (ostream &os, const pt &p) {
    os << p.x << ' ' << p.y;
    return os;
}

void move(int &i, int &j, int al) {
    if (al == 0) {
        ++j;
    }
    if (al == 45) {
        ++i;
        ++j;
    }
    if (al == 90) {
        ++i;
    }
    if (al == 135) {
        ++i;
        --j;
    }
    if (al == 180) {
        --j;
    }
    if (al == 225) {
        --i;
        --j;
    }
    if (al == 270) {
        --i;
    }
    if (al == 315) {
        --i;
        ++j;
    }
}

int f(const pt &s, const pt &f, int al) {
    if (s.x == f.x) {
        if (al == 0) {
            return 180;
        }
        if (al == 45) {
            return 135;
        }
        if (al == 135) {
            return 45;
        }
        if (al == 180) {
            return 0;
        }
        if (al == 225) {
            return 315;
        }
        if (al == 315) {
            return 225;
        }
    }
    if (s.y == f.y) {
        if (al == 45) {
            return 315;
        }
        if (al == 90) {
            return 270;
        }
        if (al == 135) {
            return 225;
        }
        if (al == 225) {
            return 135;
        }
        if (al == 270) {
            return 90;
        }
        if (al == 315) {
            return 45;
        }
    }
    if ((s.x - f.x) * (s.y - f.y) < 0) {
        if (al == 0) {
            return 270;
        }
        if (al == 45) {
            return 225;
        }
        if (al == 90) {
            return 180;
        }
        if (al == 180) {
            return 90;
        }
        if (al == 225) {
            return 45;
        }
        if (al == 270) {
            return 0;
        }
    }
    if ((s.x - f.x) * (s.y - f.y) > 0) {
        if (al == 0) {
            return 90;
        }
        if (al == 90) {
            return 0;
        }
        if (al == 135) {
            return 315;
        }
        if (al == 180) {
            return 270;
        }
        if (al == 270) {
            return 180;
        }
        if (al == 315) {
            return 135;
        }
    }

    return 0;
}

int32_t main() {
    cin.tie(0)->sync_with_stdio(0);

    int al;
    ld p;
    cin >> al >> p;

    int n;
    cin >> n;

    vector<Obj> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].s >> a[i].f >> a[i].c;
    }

    pt ex;
    cin >> ex;

    int i = 0, j = 0;
    ld p1 = p;
    while (true) {
        move(i, j, al);
        pt v(j, i);
        if (v == ex) {
            break;
        }
        for (int i = 0; i < n; ++i) {
            if (v.in(a[i].s, a[i].f)) {
                p1 *= (100 - a[i].c) / 100;
                if (p1 / p < 0.1) {
                    cout << a[i].s << ' ' << a[i].f << ' ' << p1;
                    return 0;
                }
                al = f(a[i].s, a[i].f, al);
                break;
            }
        }
    }

    cout << ll(p1);

    return 0;
}


