# === RESOURCES ID ===
# 0 spares
# 1 micro
# 2 plastic
# 3 food

# === FACTORIES ===
factories = [
    {  # 1 RECYCLER
        "need": [5, 5, 5, 0],
        "cond": 6,
        "inter_h": 2,
        "harvest": [2, 0, 1, 0],
        "inter_u": 5,
        "upkeep": [1, 0, 0, 0]
    },
    {  # 2 FOOD FACTORY
        "need": [5, 0, 10, 0],
        "cond": 4,
        "inter_h": 6,
        "harvest": [0, 0, 0, 8],
        "inter_u": 10,
        "upkeep": [0, 0, 2, 0]  # Mmm microplastics in food
    },
    {  # 3 MICRO FACTORY
        "need": [10, 5, 10, 0],
        "cond": 10,
        "inter_h": 10,
        "harvest": [0, 6, 0, 0],
        "inter_u": 20,
        "upkeep": [2, 0, 0, 0]
    },
    {  # 4 PLASTIC FACTORY
        "need": [10, 5, 8, 0],
        "cond": 8,
        "inter_h": 7,
        "harvest": [0, 0, 7, 0],
        "inter_u": 12,
        "upkeep": [1, 1, 0, 0]
    },
]

# === RESOURCES, HARVEST AND UPKEEP LOG ===
resources = [40, 40, 40, 40]
harvest = [[0, 0, 0, 0] for _ in range(100)]
upkeep = [[0, 0, 0, 0] for _ in range(100)]

# === INPUT ===
x = int(input())
y = int(input())
buildings = [[] for _ in range(100)]  # Buildings to... build
for ty in range(4):
    for _ in range(5):
        t = int(input())
        if t != 0:
            buildings[t - 1].append(ty)

# === SIMULATION ===
for d in range(100):
    for i in range(4):
        resources[i] += harvest[d][i]
        resources[i] -= upkeep[d][i]

        if d % 10 == 9:  # Resupply
            resources[i] += x
        resources[i] -= y  # Daily intake

    for b in buildings[d]:
        fb = factories[b]
        for i in range(4):  # Check if we have sufficient resources
            if fb["need"][i] > resources[i]:
                break  # TODO: Rules are murky when it comes to this part
        else:
            for i in range(4):  # Take resources for the construction
                resources[i] -= fb["need"][i]

            # Remember to add or take resources on correct days
            # (sure hope I did math correctly)
            for i in range(d + fb["cond"] + fb["inter_h"] - 1, 100, fb["inter_h"]):
                for j in range(4):
                    harvest[i][j] += fb["harvest"][j]
            for i in range(d + fb["cond"] + fb["inter_u"] - 1, 100, fb["inter_u"]):
                for j in range(4):
                    upkeep[i][j] += fb["upkeep"][j]

    # Are we out of resources or at end of mission?
    end = False
    for i in resources:
        if i <= 0:
            end = True
            break
    if end or d == 99:
        print(d + 1)
        for r in resources:
            print(r)
        break

